/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.BancoDAO;
import com.rjconsultores.ventaboletos.entidad.Banco;
import com.rjconsultores.ventaboletos.service.BancoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Rafius
 */
@Service("bancoService")
public class BancoServiceImpl implements BancoService {

    @Autowired
    private BancoDAO bancoDAO;

    public List<Banco> obtenerTodos() {
        return bancoDAO.obtenerTodos();
    }

    public Banco obtenerID(Integer id) {
        return bancoDAO.obtenerID(id);
    }

    @Transactional
    public Banco suscribir(Banco entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return bancoDAO.suscribir(entidad);
    }

    @Transactional
    public Banco actualizacion(Banco entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return bancoDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(Banco entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        bancoDAO.actualizacion(entidad);
    }

    public List<Banco> buscar(Banco banco) {
        return bancoDAO.buscar(banco);
    }
}
